gi-glib-2.0.29: GLib bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | Safe-Inferred
Language | Haskell2010

GI.GLib.Structs.MainContext

Contents

- Exported types
- Methods
  - acquire
  - addPoll
  - check
  - default
  - dispatch
  - findSourceByFuncsUserData
  - findSourceById
  - findSourceByUserData
  - getThreadDefault
  - invokeFull
  - isOwner
  - iteration
  - new
  - newWithFlags
  - pending
  - popThreadDefault
  - prepare
  - pushThreadDefault
  - query
  - ref
  - refThreadDefault
  - release
  - removePoll
  - unref
  - wait
  - wakeup

Description

The `GMainContext` struct is an opaque data type representing a set of sources to be handled in a main loop.

Synopsis

- newtype MainContext = MainContext (ManagedPtr MainContext)
- mainContextAcquire :: (HasCallStack, MonadIO m) => MainContext -> m Bool
- mainContextAddPoll :: (HasCallStack, MonadIO m) => MainContext -> PollFD -> Int32 -> m ()
- mainContextCheck :: (HasCallStack, MonadIO m) => MainContext -> Int32 -> [PollFD] -> m Bool
- mainContextDefault :: (HasCallStack, MonadIO m) => m MainContext
- mainContextDispatch :: (HasCallStack, MonadIO m) => MainContext -> m ()
- mainContextFindSourceByFuncsUserData :: (HasCallStack, MonadIO m) => MainContext -> SourceFuncs -> Ptr () -> m Source
- mainContextFindSourceById :: (HasCallStack, MonadIO m) => MainContext -> Word32 -> m Source
- mainContextFindSourceByUserData :: (HasCallStack, MonadIO m) => MainContext -> Ptr () -> m Source
- mainContextGetThreadDefault :: (HasCallStack, MonadIO m) => m (Maybe MainContext)
- mainContextInvokeFull :: (HasCallStack, MonadIO m) => MainContext -> Int32 -> SourceFunc -> m ()
- mainContextIsOwner :: (HasCallStack, MonadIO m) => MainContext -> m Bool
- mainContextIteration :: (HasCallStack, MonadIO m) => MainContext -> Bool -> m Bool
- mainContextNew :: (HasCallStack, MonadIO m) => m MainContext
- mainContextNewWithFlags :: (HasCallStack, MonadIO m) => [MainContextFlags] -> m MainContext
- mainContextPending :: (HasCallStack, MonadIO m) => MainContext -> m Bool
- mainContextPopThreadDefault :: (HasCallStack, MonadIO m) => MainContext -> m ()
- mainContextPrepare :: (HasCallStack, MonadIO m) => MainContext -> m (Bool, Int32)
- mainContextPushThreadDefault :: (HasCallStack, MonadIO m) => MainContext -> m ()
- mainContextQuery :: (HasCallStack, MonadIO m) => MainContext -> Int32 -> [PollFD] -> m (Int32, Int32, [PollFD])
- mainContextRef :: (HasCallStack, MonadIO m) => MainContext -> m MainContext
- mainContextRefThreadDefault :: (HasCallStack, MonadIO m) => m MainContext
- mainContextRelease :: (HasCallStack, MonadIO m) => MainContext -> m ()
- mainContextRemovePoll :: (HasCallStack, MonadIO m) => MainContext -> PollFD -> m ()
- mainContextUnref :: (HasCallStack, MonadIO m) => MainContext -> m ()
- mainContextWait :: (HasCallStack, MonadIO m) => MainContext -> Cond -> Mutex -> m Bool
- mainContextWakeup :: (HasCallStack, MonadIO m) => MainContext -> m ()

# Exported types

newtype MainContext Source #

Memory-managed wrapper type.

Constructors

MainContext (ManagedPtr MainContext) |

#### Instances

Instances details

Eq MainContext Source # |
Instance details Defined in GI.GLib.Structs.MainContext Methods (==) :: MainContext -> MainContext -> Bool Source # (/=) :: MainContext -> MainContext -> Bool Source #
GBoxed MainContext Source # |
Instance details Defined in GI.GLib.Structs.MainContext
ManagedPtrNewtype MainContext Source # |
Instance details Defined in GI.GLib.Structs.MainContext Methods toManagedPtr :: MainContext -> ManagedPtr MainContext Source #
TypedObject MainContext Source # |
Instance details Defined in GI.GLib.Structs.MainContext Methods glibType :: IO GType Source #
HasParentTypes MainContext Source # |
Instance details Defined in GI.GLib.Structs.MainContext
IsGValue (Maybe MainContext) Source # | Convert `MainContext` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.GLib.Structs.MainContext Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe MainContext -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe MainContext) Source #
type ParentTypes MainContext Source # |
Instance details Defined in GI.GLib.Structs.MainContext type ParentTypes MainContext = '[] :: [Type]

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

acquire, addPoll, check, dispatch, findSourceByFuncsUserData, findSourceById, findSourceByUserData, invokeFull, isOwner, iteration, pending, popThreadDefault, prepare, pushThreadDefault, query, ref, release, removePoll, unref, wait, wakeup.

#### Getters

None.

#### Setters

None.

## acquire

mainContextAcquire Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> m Bool | Returns: `True` if the operation succeeded, and this thread is now the owner of `context`.

Tries to become the owner of the specified context. If some other thread is the owner of the context, returns `False` immediately. Ownership is properly recursive: the owner can require ownership again and will release ownership when `mainContextRelease` is called as many times as `mainContextAcquire`.

You must be the owner of a context before you can call `mainContextPrepare`, `mainContextQuery`, `mainContextCheck`, `mainContextDispatch`, `mainContextRelease`.

Since 2.76 `context` can be `Nothing` to use the global-default main context.

## addPoll

mainContextAddPoll Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (or `Nothing` for the global-default main context)
-> PollFD | `fd`: a `PollFD` structure holding information about a file descriptor to watch.
-> Int32 | `priority`: the priority for this file descriptor which should be the same as the priority used for `sourceAttach` to ensure that the file descriptor is polled whenever the results may be needed.
-> m () |

Adds a file descriptor to the set of file descriptors polled for this context. This will very seldom be used directly. Instead a typical event source will use `sourceAddUnixFd` instead.

## check

mainContextCheck Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> Int32 | `maxPriority`: the maximum numerical priority of sources to check
-> [PollFD] | `fds`: array of `PollFD`'s that was passed to the last call to `mainContextQuery`
-> m Bool | Returns: `True` if some sources are ready to be dispatched.

Passes the results of polling back to the main loop. You should be careful to pass `fds` and its length `nFds` as received from `mainContextQuery`, as this functions relies on assumptions on how `fds` is filled.

You must have successfully acquired the context with `mainContextAcquire` before you may call this function.

Since 2.76 `context` can be `Nothing` to use the global-default main context.

## default

mainContextDefault Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m MainContext | Returns: the global-default main context.

Returns the global-default main context. This is the main context used for main loop functions when a main loop is not explicitly specified, and corresponds to the "main" main loop. See also `mainContextGetThreadDefault`.

## dispatch

mainContextDispatch Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> m () |

Dispatches all pending sources.

You must have successfully acquired the context with `mainContextAcquire` before you may call this function.

Since 2.76 `context` can be `Nothing` to use the global-default main context.

## findSourceByFuncsUserData

mainContextFindSourceByFuncsUserData Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used).
-> SourceFuncs | `funcs`: the `sourceFuncs` passed to `sourceNew`.
-> Ptr () | `userData`: the user data from the callback.
-> m Source | Returns: the source, if one was found, otherwise `Nothing`

Finds a source with the given source functions and user data. If multiple sources exist with the same source function and user data, the first one found will be returned.

## findSourceById

mainContextFindSourceById Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> Word32 | `sourceId`: the source ID, as returned by `sourceGetId`.
-> m Source | Returns: the `Source`

Finds a `Source` given a pair of context and ID.

It is a programmer error to attempt to look up a non-existent source.

More specifically: source IDs can be reissued after a source has been destroyed and therefore it is never valid to use this function with a source ID which may have already been removed. An example is when scheduling an idle to run in another thread with `g_idle_add()`: the idle may already have run and been removed by the time this function is called on its (now invalid) source ID. This source ID may have been reissued, leading to the operation being performed against the wrong source.

## findSourceByUserData

mainContextFindSourceByUserData Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> Ptr () | `userData`: the user_data for the callback.
-> m Source | Returns: the source, if one was found, otherwise `Nothing`

Finds a source with the given user data for the callback. If multiple sources exist with the same user data, the first one found will be returned.

## getThreadDefault

mainContextGetThreadDefault Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m (Maybe MainContext) | Returns: the thread-default `MainContext`, or `Nothing` if the thread-default context is the global-default main context.

Gets the thread-default `MainContext` for this thread. Asynchronous operations that want to be able to be run in contexts other than the default one should call this method or `mainContextRefThreadDefault` to get a `MainContext` to add their `GSources` to. (Note that even in single-threaded programs applications may sometimes want to temporarily push a non-default context, so it is not safe to assume that this will always return `Nothing` if you are running in the default thread.)

If you need to hold a reference on the context, use `mainContextRefThreadDefault` instead.

Since: 2.22

## invokeFull

mainContextInvokeFull Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext`, or `Nothing` for the global-default main context
-> Int32 | `priority`: the priority at which to run `function`
-> SourceFunc | `function`: function to call
-> m () |

Invokes a function in such a way that `context` is owned during the invocation of `function`.

This function is the same as `g_main_context_invoke()` except that it lets you specify the priority in case `function` ends up being scheduled as an idle and also lets you give a `DestroyNotify` for `data`.

`notify` should not assume that it is called from any particular thread or with any particular context acquired.

Since: 2.28

## isOwner

mainContextIsOwner Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> m Bool | Returns: `True` if current thread is owner of `context`.

Determines whether this thread holds the (recursive) ownership of this `MainContext`. This is useful to know before waiting on another thread that may be blocking to get ownership of `context`.

Since: 2.10

## iteration

mainContextIteration Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> Bool | `mayBlock`: whether the call may block.
-> m Bool | Returns: `True` if events were dispatched.

Runs a single iteration for the given main loop. This involves checking to see if any event sources are ready to be processed, then if no events sources are ready and `mayBlock` is `True`, waiting for a source to become ready, then dispatching the highest priority events sources that are ready. Otherwise, if `mayBlock` is `False` sources are not waited to become ready, only those highest priority events sources will be dispatched (if any), that are ready at this given moment without further waiting.

Note that even when `mayBlock` is `True`, it is still possible for `mainContextIteration` to return `False`, since the wait may be interrupted for other reasons than an event source becoming ready.

## new

mainContextNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m MainContext | Returns: the new `MainContext`

Creates a new `MainContext` structure.

## newWithFlags

mainContextNewWithFlags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> [MainContextFlags] | `flags`: a bitwise-OR combination of `MainContextFlags` flags that can only be set at creation time.
-> m MainContext | Returns: the new `MainContext`

Creates a new `MainContext` structure.

Since: 2.72

## pending

mainContextPending Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> m Bool | Returns: `True` if events are pending.

Checks if any sources have pending events for the given context.

## popThreadDefault

mainContextPopThreadDefault Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext`, or `Nothing` for the global-default main context
-> m () |

Pops `context` off the thread-default context stack (verifying that it was on the top of the stack).

Since: 2.22

## prepare

mainContextPrepare Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> m (Bool, Int32) | Returns: `True` if some source is ready to be dispatched prior to polling.

Prepares to poll sources within a main loop. The resulting information for polling is determined by calling g_main_context_query ().

You must have successfully acquired the context with `mainContextAcquire` before you may call this function.

## pushThreadDefault

mainContextPushThreadDefault Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext`, or `Nothing` for the global-default main context
-> m () |

Acquires `context` and sets it as the thread-default context for the current thread. This will cause certain asynchronous operations (such as most [gio][gio]-based I/O) which are started in this thread to run under `context` and deliver their results to its main loop, rather than running under the global default main context in the main thread. Note that calling this function changes the context returned by `mainContextGetThreadDefault`, not the one returned by `mainContextDefault`, so it does not affect the context used by functions like `g_idle_add()`.

Normally you would call this function shortly after creating a new thread, passing it a `MainContext` which will be run by a `MainLoop` in that thread, to set a new default context for all async operations in that thread. In this case you may not need to ever call `mainContextPopThreadDefault`, assuming you want the new `MainContext` to be the default for the whole lifecycle of the thread.

If you don't have control over how the new thread was created (e.g. in the new thread isn't newly created, or if the thread life cycle is managed by a `ThreadPool`), it is always suggested to wrap the logic that needs to use the new `MainContext` inside a `mainContextPushThreadDefault` / `mainContextPopThreadDefault` pair, otherwise threads that are re-used will end up never explicitly releasing the `MainContext` reference they hold.

In some cases you may want to schedule a single operation in a non-default context, or temporarily use a non-default context in the main thread. In that case, you can wrap the call to the asynchronous operation inside a `mainContextPushThreadDefault` / `mainContextPopThreadDefault` pair, but it is up to you to ensure that no other asynchronous operations accidentally get started while the non-default context is active.

Beware that libraries that predate this function may not correctly handle being used from a thread with a thread-default context. Eg, see `g_file_supports_thread_contexts()`.

Since: 2.22

## query

mainContextQuery Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> Int32 | `maxPriority`: maximum priority source to check
-> [PollFD] | `fds`: location to store `PollFD` records that need to be polled.
-> m (Int32, Int32, [PollFD]) | Returns: the number of records actually stored in `fds`, or, if more than `nFds` records need to be stored, the number of records that need to be stored.

Determines information necessary to poll this main loop. You should be careful to pass the resulting `fds` array and its length `nFds` as is when calling `mainContextCheck`, as this function relies on assumptions made when the array is filled.

You must have successfully acquired the context with `mainContextAcquire` before you may call this function.

## ref

mainContextRef Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext`
-> m MainContext | Returns: the `context` that was passed in (since 2.6)

Increases the reference count on a `MainContext` object by one.

## refThreadDefault

mainContextRefThreadDefault Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m MainContext | Returns: the thread-default `MainContext`. Unref with `mainContextUnref` when you are done with it.

Gets the thread-default `MainContext` for this thread, as with `mainContextGetThreadDefault`, but also adds a reference to it with `mainContextRef`. In addition, unlike `mainContextGetThreadDefault`, if the thread-default context is the global-default context, this will return that `MainContext` (with a ref added to it) rather than returning `Nothing`.

Since: 2.32

## release

mainContextRelease Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> m () |

Releases ownership of a context previously acquired by this thread with `mainContextAcquire`. If the context was acquired multiple times, the ownership will be released only when `mainContextRelease` is called as many times as it was acquired.

You must have successfully acquired the context with `mainContextAcquire` before you may call this function.

## removePoll

mainContextRemovePoll Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> PollFD | `fd`: a `PollFD` descriptor previously added with `mainContextAddPoll`
-> m () |

Removes file descriptor from the set of file descriptors to be polled for a particular context.

## unref

mainContextUnref Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext`
-> m () |

Decreases the reference count on a `MainContext` object by one. If the result is zero, free the context and free all associated memory.

## wait

mainContextWait Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> Cond | `cond`: a condition variable
-> Mutex | `mutex`: a mutex, currently held
-> m Bool | Returns: `True` if the operation succeeded, and this thread is now the owner of `context`.

Deprecated: (Since version 2.58)Use `mainContextIsOwner` and separate locking instead.

Tries to become the owner of the specified context, as with `mainContextAcquire`. But if another thread is the owner, atomically drop `mutex` and wait on `cond` until that owner releases ownership or until `cond` is signaled, then try again (once) to become the owner.

## wakeup

mainContextWakeup Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MainContext | `context`: a `MainContext` (if `Nothing`, the global-default main context will be used)
-> m () |

If `context` is currently blocking in `mainContextIteration` waiting for a source to become ready, cause it to stop blocking and return. Otherwise, cause the next invocation of `mainContextIteration` to return without blocking.

This API is useful for low-level control over `MainContext`; for example, integrating it with main loop implementations such as `MainLoop`.

Another related use for this function is when implementing a main loop with a termination condition, computed from multiple threads:

### C code

     #define NUM_TASKS 10
     static gint tasks_remaining = NUM_TASKS;  // (atomic)
     ...

     while (g_atomic_int_get (&tasks_remaining) != 0)
       g_main_context_iteration (NULL, TRUE);

Then in a thread:

### C code

     perform_work();

     if (g_atomic_int_dec_and_test (&tasks_remaining))
       g_main_context_wakeup (NULL);